com.holonplatform.vaadin.navigator.internal

## Interface ViewConfiguration

- All Superinterfaces:
    Consumer<ViewWindowConfigurator>, Serializable
  All Known Implementing Classes:
    DefaultViewConfiguration

      public interface ViewConfiguration
      extends Consumer<ViewWindowConfigurator>, Serializable

  `View` configuration representation.

  This class is intended for internal framework use only.

  Since:
    5.0.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `ViewConfiguration.ViewConfigurationException` Exception related to `View` configuration errors.
    `static interface` | `ViewConfiguration.ViewConfigurationProvider` Provider of `ViewConfiguration`s.
    `static interface` | `ViewConfiguration.ViewParameterDefinition` View parameter definition.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Optional<com.holonplatform.auth.annotations.Authenticate>` | `getAuthentication()` Get the optional view `Authenticate` annotation.
    `String` | `getCaption()` Get optional view caption
    `String` | `getCaptionMessageCode()` Get optional view caption translation message code
    `Collection<ViewContextField>` | `getContextInjectionFields()` View class fields which declare `ViewContext` data injection
    `List<Method>` | `getOnLeaveMethods()` Get view `OnLeave` methods
    `List<Method>` | `getOnShowMethods()` Get view `OnShow` methods
    `Collection<ViewConfiguration.ViewParameterDefinition>` | `getParameters()` Get View declared parameters
    `String` | `getParentViewName()` If `isSubView()`, get parent View name
    `List<Method>` | `getViewWindowConfigurationMethods()` Get view `ViewWindowConfiguration` methods.
    `boolean` | `isFireOnRefresh(Method onShowMethod)` Check whether given `OnShow` method must be called also at browser page refresh
    `boolean` | `isForceInWindow()` Gets whether this view must be displayed in a Window
    `boolean` | `isSubView()` Gets whether the view class is a sub view
    `boolean` | `isSubViewContainer()` Gets whether the view class is a `SubViewContainer`
    `boolean` | `isVolatile()` Gets whether this view is volatile (not to be tracked in navigation history)

    - ### Methods inherited from interface java.util.function.Consumer

      `accept, andThen`

- - ### Method Detail

    - #### isVolatile

          boolean isVolatile()

      Gets whether this view is volatile (not to be tracked in navigation history)
      Returns:
        `true` if this view is volatile
      See Also:
        `VolatileView`

    - #### isForceInWindow

          boolean isForceInWindow()

      Gets whether this view must be displayed in a Window
      Returns:
        `true` if this view must be displayed in a Window
      See Also:
        `WindowView`

    - #### isSubView

          boolean isSubView()

      Gets whether the view class is a sub view
      Returns:
        `true` if the view class is a sub view

    - #### isSubViewContainer

          boolean isSubViewContainer()

      Gets whether the view class is a `SubViewContainer`
      Returns:
        `true` if the view class is a `SubViewContainer`

    - #### getParentViewName

          String getParentViewName()

      If `isSubView()`, get parent View name
      Returns:
        Parent View name, or `null` if it is not a sub view

    - #### getCaption

          String getCaption()

      Get optional view caption
      Returns:
        View caption, or `null` if not defined
      See Also:
        `Caption`

    - #### getCaptionMessageCode

          String getCaptionMessageCode()

      Get optional view caption translation message code
      Returns:
        View caption translation message code, or `null` if not defined
      See Also:
        `Caption`

    - #### getParameters

          Collection<ViewConfiguration.ViewParameterDefinition> getParameters()

      Get View declared parameters
      Returns:
        View declared parameters, or an empty set if no parameter declared

    - #### getOnShowMethods

          List<Method> getOnShowMethods()

      Get view `OnShow` methods
      Returns:
        OnShow methods in call order, or an empty list if none

    - #### isFireOnRefresh

          boolean isFireOnRefresh(Method onShowMethod)

      Check whether given `OnShow` method must be called also at browser page refresh
      Parameters:
        `onShowMethod` - Method to check
      Returns:
        `true` if method must be called also at browser page refresh

    - #### getOnLeaveMethods

          List<Method> getOnLeaveMethods()

      Get view `OnLeave` methods
      Returns:
        OnLeave methods in call order, or an empty list if none

    - #### getViewWindowConfigurationMethods

          List<Method> getViewWindowConfigurationMethods()

      Get view `ViewWindowConfiguration` methods.
      Returns:
        ViewWindowConfiguration methods in call order, or an empty list if none

    - #### getContextInjectionFields

          Collection<ViewContextField> getContextInjectionFields()

      View class fields which declare `ViewContext` data injection
      Returns:
        Context inection fields, or an empty set if none

    - #### getAuthentication

          Optional<com.holonplatform.auth.annotations.Authenticate> getAuthentication()

      Get the optional view `Authenticate` annotation.
      Returns:
        View `Authenticate` annotation

Copyright © 2019 The Holon Platform. All rights reserved.